package com.good.ca.protocol.authentication;

import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.HttpClient;
import org.apache.http.impl.client.DefaultHttpClient;

public class BasicAuthentication implements HttpAuthentication {

    public String userName = null;
    private String passWord = null;

    public BasicAuthentication(final String userName,
                               final String passWord) {
        this.userName = userName;
        this.passWord = passWord;
    }

    @Override
    public HttpClient getClient() throws HttpAuthenticationException {
        DefaultHttpClient httpClient;
        try {
            httpClient = new DefaultHttpClient();
            httpClient.getCredentialsProvider().setCredentials(
                    AuthScope.ANY,
                    new UsernamePasswordCredentials(this.userName, this.passWord));
        } catch (Exception e) {
            throw new HttpAuthenticationException(e);
        }
        return httpClient;
    }

    public String getUserName() {
        return this.userName;
    }

    protected void setUserName(final String userName) {
        this.userName = userName;
    }

    public String getPassWord() {
        return this.passWord;
    }

    protected void setPassWord(final String passWord) {
        this.passWord = passWord;
    }

    @Override
    public AuthenticationType getType() {
        return AuthenticationType.BASIC_AUTH;
    }


}
