package com.good.ca.protocol.authentication;

import com.good.ca.protocol.ConnectionStatusCode;

public class HttpAuthenticationException extends Exception {

	private static final long serialVersionUID = 990691581888466621L;

	protected ConnectionStatusCode errorCode;

	public HttpAuthenticationException(Exception e) {
		super(e);
	}

	public HttpAuthenticationException(String message, Throwable t) {
		super(message, t);
	}

	public HttpAuthenticationException(String message) {
		super(message);
	}

    public HttpAuthenticationException(String message, ConnectionStatusCode code) {
        super(message);
        errorCode = code;
    }

	public HttpAuthenticationException(String message, Throwable t, ConnectionStatusCode code) {
        super(message, t);
		errorCode = code;
	}

	public ConnectionStatusCode getErrorCode() {
		return errorCode;
	}

}
