package com.good.ca.protocol.bean;

import org.apache.commons.lang.StringUtils;

import java.util.Arrays;
import java.util.stream.Collectors;

/**
 * Enum for possible PKI connector capabilities.
 */
public enum PkiConnectorCapabilities {
    GET_P12("getP12"),
    SIGN_CERT("signCert"),
    RENEW_CERT("renewCert"),
	NOTIFY_CERTIFICATE_RECEIVED("notifyCertificateReceived"),
	NOTIFY_CERTIFICATE_REMOVED("notifyCertificateRemoved");
	
    private final String value;

    PkiConnectorCapabilities(String val) {
        this.value = val;
    }

    public String getValue() {
        return this.value;
    }

}
