package com.good.ca.protocol.bean;

import com.good.ca.protocol.authentication.HttpAuthentication;
import com.good.ca.protocol.exception.RequiredParamException;
import com.good.util.RandomUtil;
import com.good.util.validation.ClassValidation;
import com.google.gson.JsonObject;
import org.apache.commons.codec.binary.Base64;

import static java.nio.charset.StandardCharsets.UTF_8;

public abstract class RequestCertificateAuthority implements
		IRequestCertificateAuthority {

	private final static String REQUIRED_PARAM_ERROR = "ERROR Required fields are empty";

	public HttpAuthentication authentication;
	
	RequestCertificateAuthority() {
		setHttpType();
	}

	public HttpAuthentication getAuthentication() {
		return this.authentication;
	}

	public void setAuthentication(HttpAuthentication authentication) {
		this.authentication = authentication;
	}

	String getRequestId() {
		return new String(Base64.encodeBase64(RandomUtil.generateRandomBytes(64)), UTF_8);
	}

	public abstract JsonObject getMessage();

	public abstract void setHttpType();

	public enum HttpType {
		POST, GET;
	}

	HttpType httpType = null;

	public HttpType getHttpType() {
		return this.httpType;
	}

	protected void checkRequiredFields(Object toCheck) {
		if (!ClassValidation.validateNotEmpty(toCheck)) throw new RequiredParamException(REQUIRED_PARAM_ERROR);
	}
}
