package com.good.ca.protocol.bean;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public abstract class ResponseCertificateAuthority {
	
	private JSONObject jsonObject = null;
	private String json = null;

	public ResponseCertificateAuthority(final String json) throws JSONException {
		this.jsonObject = new JSONObject(json);
		this.json = json;
	}
	
	public String getId() throws JSONException {
		return getRequiredString("reqId");
	}

	public String getJson() {
		return this.json;
	}

	public JSONObject getJSONObject() {
		return this.jsonObject;
	}

	protected String getOptionalString(String param) throws JSONException {
		return (paramIsPresent(param)) ? this.jsonObject.optString(param) : null;
	}

	protected Object getOptionalObject(String param) throws JSONException {
		return (paramIsPresent(param)) ? this.jsonObject.opt(param) : null;
	}

	protected String getRequiredString(String param) throws JSONException {
		return (paramIsPresent(param)) ? this.jsonObject.getString(param) : null;
	}

	protected JSONArray getOptionalArray(String param) throws JSONException {
		return (paramIsPresent(param)) ? this.jsonObject.optJSONArray(param) : null;
	}

	private boolean paramIsPresent(String param) {
		return !this.jsonObject.isNull(param);
	}

}
