package com.good.ca.protocol.bean;

import org.json.JSONException;

/**
 * Response for notifyCertificateRemoved operation
 */
public class ResponseNotifyCertificateRemoved extends ResponseCertificateAuthority {
    /**
     * Status of operation(success/failure). Mandatory field.
     */
    private String status = null;
    /**
     * Information about failure
     */
    private String failureInfo = null;

    public ResponseNotifyCertificateRemoved(String json) throws JSONException {
        super(json);
        parseResponse();
    }

    public String getStatus() throws JSONException {
        return status;
    }

    public String getFailureInfo() throws JSONException {
        return failureInfo;
    }

    @Override
    public String toString() {
        return "ResponseNotifyCertificateRemoved{" +
                "status=" + status +
                ", failureInfo='" + failureInfo + '\'' +
                '}';
    }

    private void parseResponse() throws JSONException {
        status = getRequiredString("status");
        failureInfo = getOptionalString("failureInfo");
    }
    public boolean isRetryable(){
    	if(status != null && "failure".equalsIgnoreCase(status) && failureInfo != null && "retry".equalsIgnoreCase(failureInfo))
    		return true;
    	
    	return false;
    				
    }
}
