package com.good.ca.protocol.service;

import com.good.ca.protocol.authentication.HttpAuthenticationException;
import com.good.ca.protocol.bean.*;

import java.io.IOException;

public interface CertificateAuthorityService {

	/**
	 * 
	 * @param request
	 * @return
	 */
	public ResponseCAKeyPair requestKeyPair(final String url,
			final RequestCAKeyPair request)
			throws CertificateAuthorityServiceException;

	/**
	 * 
	 * @param revokeRequest
	 * @return
	 */
	public ResponseCARevoke requestRevoke(final String url,
			final RequestCARevoke revokeRequest)
			throws CertificateAuthorityServiceException;

    /**
     *
     * @param
     * @return
     */
    public ResponseCAGetInfo getInfo(final String url,
                                            final RequestCAGetInfo request)
            throws CertificateAuthorityServiceException, IOException, HttpAuthenticationException;

	
	/**
	 * @param url to PKI connector
	 * @param request {@Link RequestSignCertificate} request DTO for signCertificate
	 * @return {@Link ResponseSignCertificate} response DTO for signCertificate
	 */
	ResponseSignCertificate signCertificate(final String url,
												 final RequestSignCertificate request) throws CertificateAuthorityServiceException;

	/**
	 * @param url to PKI connector
	 * @param request {@Link RequestCAKeyPair2} request DTO for getUserKeyPair2
	 * @return {@Link ResponseCAKeyPair2} response DTO for getUserKeyPair2
	 */
	ResponseCAKeyPair2 getUserKeyPair2(final String url,
									   final RequestCAKeyPair2 request) throws CertificateAuthorityServiceException;
	/**
	 * @param url to PKI connector
	 * @param request {@Link RequestNotifyCertificateReceived} request DTO for notifyCertificateReceived
	 */
	ResponseNotifyCertificateReceived notifyCertificateReceived(final String url,final RequestNotifyCertificateReceived request) throws CertificateAuthorityServiceException;

	/**
	 * @param url to PKI connector
	 * @param request {@Link RequestNotifyCertificateRemoved} request DTO for notifyCertificateRemoved
	 */
	ResponseNotifyCertificateRemoved notifyCertificateRemoved(final String url, final RequestNotifyCertificateRemoved request) throws CertificateAuthorityServiceException;

}
